; 11/20/93
;
; About CHKFLP.COM (it can be renamed !)
;
; It appears that the program can't address the hardware if it uses PD's
; Dos environment so it needs to load its own. This, according to Paradox
; documentation will prevent a PAL program from getting an errorlevel from
; CHKFLP in Retval. So it has to be run without the NoShell option.
; In order to get the floppy drive(s) status and whether a diskette placed
; in a drive has a write protected tab, the PAL program must Play a .SC
; file that CHKFLP creates in current directory. The file is RREETT.SC
; (hopping there isn't a file with the same name... I hard coded this
; stupid name...)
;
; The .SC file has one line in it: Retval = n where "n" is either 0, 1 or 2.
; 0 = Request tested Ok, 1 = Drive not ready, 2 = Diskette write protected.
;
; CHKFLP command line switches and arguments specified are case insensitive.
; Switches and usage:
; /h or -h  Displays switch usage. DON'T use it from Paradox, does't do
;           anything...
; /d or -d  Specifies drive to be checked. If this switched is not used
;           the program uses default A. Arguments possible are A or B
;           Usage: CHKFLP /da   check drive A
; /t or -t  What to check. Arguments are R or W (check if Ready, check if
;           Write on diskette is possible)
;           Usage: CHKFLP /tw   check if disk in drive A is write protected
; /v or -v  Specify another variable name than RETVAL. Right after the
;           switch put one letter. More than one will be truncated..
;           Default is RETVAL if switched /v is not used or used without
;           specifying one letter.
;
; Since this utility is a quick thing it doesn't do any fancy parsing on
; switches so keep them at one letter. I placed the /v switched in case
; someone doesn't want to alter RETVAL but the limitation is one letter...
; [better stop here.. before this utility grows too big !]
;
; It takes either 1, 2 3 or no switches.
; CHKFLP can be in current directory or can be called with a full path. For
; the latter use duble slashes: Run NoRefresh "e:\\util\\pdutl\\chkflp /tw"
;
; Call Examples (assumes current directory)
; * Check if drive A is ready:
;            Run NoRefresh "chkflp"
; * Check if diskette in drive A can be written:
;            Run NoRefresh "chkflp /tw"
; * Check if diskette in drive B can be written:
;            Run NoRefresh "chkflp /db /tw"
; * Check if drive A is ready and use variable name "Q" in output .sc file
;            Run NoRefresh "chkflp /vq"
;
;      NOTE: If you have a write protected diskette in a drive and call this
;            program without /t switch the variable returned will be 0 (zero)
;            so if write protect check is needed use /tw
;
; Also... because shelling out and doing this type of things from Paradox is
; not on the fast side... perhaps augmenting the routine which uses this
; utility with some messages would divert user's attention from the speed...
;
; Looking at the second example it appears that CHKFLP checks if the drive
; is ready firts and in fact this is what it always does.. The reason for 2
; switches is that if we don't need to write to the disk we shouldn't use
; /t switch which adds more work...
;
; To test this in dos run the program with adequate switches then look at
; the RREETT.SC file created in current directory (type rreett.sc)


   ;-- A simple script to test CHKFLP
   msg.a = ""
   Run NoRefresh "chkflp /tw"  ; Check diskette in A: if write protected
   Play "RREETT"
   Switch
     Case Retval = 1:
        msg.a = "Drive Not Ready"
     Case Retval = 2:
        msg.a = "Diskette is write protected"
     Otherwise:
        msg.a = "Drive and/or diskette checks Ok"
   Endswitch
   If Retval <> 0 Then
      Beep Beep
   Endif
   ;-- We can zap the file here although it
   ;   is ovewritten at each call to CHKFLP.
   ;   Code below assumes paradox 4.x
   Editor New "RREETT.SC"
   {Cancel} {Yes}
   ;-- Exit with message
   Quit msg.a + " " + Chr(179) +" Retval: " +Strval(retval)
